from logging import getLogger
from pequod_agent.cluster.service import ClusterService

INFRASTRUCTURE_ZONE = 'infrastructure'


class AppService(ClusterService):
    def __init__(self, controller, registry, zone_name, service_name, service_version, credentials):
        super().__init__(credentials)
        self.controller = controller
        self.registry = registry
        self.identifier = zone_name, service_name, service_version
        self.log = getLogger('pequod.app-service')

    @property
    def endpoints(self):
        cluster_state = self.controller.poll()
        return list(cluster_state.discover_instance_endpoints(self.registry, *self.identifier))

    @property
    def name(self):
        return '{}/{}:{}'.format(*self.identifier)